/*
 * This file is part of the Score-P software (http://www.score-p.org)
 *
 * Copyright (c) 2009-2011,
 * RWTH Aachen University, Germany
 *
 * Copyright (c) 2009-2011,
 * Gesellschaft fuer numerische Simulation mbH Braunschweig, Germany
 *
 * Copyright (c) 2009-2011, 2015,
 * Technische Universitaet Dresden, Germany
 *
 * Copyright (c) 2009-2011,
 * University of Oregon, Eugene, USA
 *
 * Copyright (c) 2009-2011,
 * Forschungszentrum Juelich GmbH, Germany
 *
 * Copyright (c) 2009-2011,
 * German Research School for Simulation Sciences GmbH, Juelich/Aachen, Germany
 *
 * Copyright (c) 2009-2011,
 * Technische Universitaet Muenchen, Germany
 *
 * This software may be modified and distributed under the terms of
 * a BSD-style license. See the COPYING file in the package base
 * directory for details.
 *
 */

#ifndef SCOREP_DEFINITIONHANDLES_H
#define SCOREP_DEFINITIONHANDLES_H



/**
 * @file
 *
 *
 */


#include <scorep/SCOREP_PublicTypes.h>


typedef SCOREP_AnyHandle SCOREP_StringHandle;


typedef SCOREP_AnyHandle SCOREP_SystemTreeNodeHandle;


typedef SCOREP_AnyHandle SCOREP_SystemTreeNodePropertyHandle;


typedef SCOREP_AnyHandle SCOREP_LocationGroupHandle;


typedef SCOREP_AnyHandle SCOREP_LocationHandle;


typedef SCOREP_AnyHandle SCOREP_GroupHandle;


typedef SCOREP_AnyHandle SCOREP_InterimCommunicatorHandle;


typedef SCOREP_AnyHandle SCOREP_CommunicatorHandle;


typedef SCOREP_AnyHandle SCOREP_InterimRmaWindowHandle;


typedef SCOREP_AnyHandle SCOREP_RmaWindowHandle;


typedef SCOREP_AnyHandle SCOREP_MPICartesianTopologyHandle;


typedef SCOREP_AnyHandle SCOREP_MPICartesianCoordsHandle;


typedef SCOREP_AnyHandle SCOREP_IOFileGroupHandle;


typedef SCOREP_AnyHandle SCOREP_IOFileHandle;


typedef SCOREP_AnyHandle SCOREP_MarkerGroupHandle;


typedef SCOREP_AnyHandle SCOREP_MarkerHandle;


typedef SCOREP_AnyHandle SCOREP_ParameterHandle;


typedef SCOREP_AnyHandle SCOREP_CallpathHandle;


typedef SCOREP_AnyHandle SCOREP_PropertyHandle;


typedef SCOREP_AnyHandle SCOREP_SamplingSetRecorderHandle;


typedef SCOREP_AnyHandle SCOREP_AttributeHandle;


typedef SCOREP_AnyHandle SCOREP_LocationPropertyHandle;


typedef SCOREP_AnyHandle SCOREP_SourceCodeLocationHandle;


typedef SCOREP_AnyHandle SCOREP_CallingContextHandle;


typedef SCOREP_AnyHandle SCOREP_InterruptGeneratorHandle;


#endif /* SCOREP_DEFINITIONHANDLES_H */
